#include "CoreSegment.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::ltm
{

    wm::CoreSegment CoreSegment::convert() const
    {
        wm::CoreSegment m;
        for (const auto& [_, s] : _container)
        {
            m.addProviderSegment(s.convert());
        }
        return m;
    }

    void CoreSegment::append(const wm::CoreSegment& m)
    {
        for (const auto& [k, s] : m.container())
        {
            if (const auto& it = _container.find(k); it != _container.end())
            {
                it->second.append(s);
            }
            else
            {
                auto wms = _container.emplace(std::make_pair(k, id().withCoreSegmentName(k)));
                wms.first->second.append(s);
            }
        }
    }
}
