#pragma once

#include "../base/EntitySnapshotBase.h"

#include "EntityInstance.h"

#include "../workingmemory/EntitySnapshot.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        using Base::EntitySnapshotBase;
        using Base::operator=;


        // Conversion
        wm::EntitySnapshot convert() const;

        // MongoDB connection
        void setTo(const wm::EntitySnapshot&);
    };
}
