#pragma once

#include "BaseQueryProcessor.h"
#include "../base/CoreSegmentQueryProcessorBase.h"

#include "ProviderSegmentQueryProcessor.h"


namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class CoreSegmentQueryProcessor :
        virtual public BaseQueryProcessor<wm::CoreSegment, armem::query::data::CoreSegmentQuery>,
        virtual public base::query_proc::CoreSegmentQueryProcessorBase<wm::CoreSegment>
    {
        using Base = BaseQueryProcessor<wm::CoreSegment, armem::query::data::CoreSegmentQuery>;

    public:
        CoreSegmentQueryProcessor(DataMode dataMode = DataMode::WithData) :
            Base(dataMode), providerSegmentProcessor(dataMode)
        {}

        using Base::process;
        data::CoreSegment processToIce(const armem::query::data::CoreSegmentQuery& query, const wm::CoreSegment& coreSegment) const
        {
            return toIce<data::CoreSegment>(process(query, coreSegment));
        }

    protected:
        virtual ProviderSegmentT providerSegmentProcessorProcess(const armem::query::data::ProviderSegmentQuerySeq& q, const ProviderSegmentT& s) const override
        {
            return providerSegmentProcessor.process(q, s);
        }

    private:
        ProviderSegmentQueryProcessor providerSegmentProcessor;
    };
}
