#pragma once

#include "BaseQueryProcessor.h"
#include "../base/EntityQueryProcessorBase.h"

#include "EntityQueryProcessor.h"

namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class EntityQueryProcessor :
        virtual public BaseQueryProcessor<wm::Entity, armem::query::data::EntityQuery>,
        virtual public base::query_proc::EntityQueryProcessorBase<wm::Entity>
    {
        using Base = BaseQueryProcessor<wm::Entity, armem::query::data::EntityQuery>;

    public:
        EntityQueryProcessor(DataMode dataMode = DataMode::WithData) :
            Base(dataMode)
        {}

        data::Entity processToIce(const armem::query::data::EntityQuery& query, const wm::Entity& entity) const
        {
            return toIce<data::Entity>(process(query, entity));
        }

    private:
        void addResultSnapshot(wm::Entity& result, wm::Entity::ContainerT::const_iterator it) const override
        {
            addResultSnapshot(result, it->second);
        }

        void addResultSnapshot(wm::Entity& result, const wm::EntitySnapshot& snapshot) const override
        {
            bool withData = (dataMode == DataMode::WithData);
            if (withData)
            {
                result.addSnapshot(snapshot.copy());
            }
            else
            {
                result.addSnapshot(snapshot.copyWithoutData());
            }
        }

    };

}
