#pragma once

#include <map>
#include <vector>
#include <filesystem>

#include <Eigen/Geometry>

#include <IceUtil/Time.h>

#include <ArmarXCore/core/PackagePath.h>

namespace armarx::armem::robot
{
    struct RobotDescription
    {
        // IceUtil::Time timestamp;

        std::string name;
        PackagePath xml{"", std::filesystem::path("")};
    };

    struct RobotState
    {
        IceUtil::Time timestamp;

        Eigen::Affine3f globalPose;
        std::map<std::string, float> jointMap;
    };

    struct Robot
    {
        RobotDescription description;
        std::string instance;

        RobotState config;

        IceUtil::Time timestamp;
    };

    using Robots = std::vector<Robot>;
    using RobotDescriptions = std::vector<RobotDescription>;
    using RobotStates = std::vector<RobotState>;

}  // namespace armarx::armem::robot