#include "aron_conversions.h"

// STL
#include <string>

// Ice
#include <IceUtil/Time.h>

// RobotAPI
#include <RobotAPI/libraries/armem_robot_state/aron/Transform.aron.generated.h>
#include <RobotAPI/libraries/armem_robot_state/aron/JointState.aron.generated.h>

#include <RobotAPI/libraries/aron/common/aron_conversions.h>

#include "RobotAPI/libraries/armem_robot_state/types.h"

namespace armarx::armem
{

    /* Transform */

    void fromAron(const arondto::Transform& dto, robot_state::Transform& bo)
    {
        fromAron(dto.header, bo.header);
        aron::fromAron(dto.transform, bo.transform);
    }

    void toAron(arondto::Transform& dto, const robot_state::Transform& bo)
    {
        toAron(dto.header, bo.header);
        aron::toAron(dto.transform, bo.transform);
    }

    /* TransformHeader */

    void toAron(arondto::TransformHeader& dto, const robot_state::TransformHeader& bo)
    {
        aron::toAron(dto.parentFrame, bo.parentFrame);
        aron::toAron(dto.frame, bo.frame);
        aron::toAron(dto.agent, bo.agent);
        aron::toAron(dto.timestamp, bo.timestamp);
    }

    void fromAron(const arondto::TransformHeader& dto, robot_state::TransformHeader& bo)
    {
        aron::fromAron(dto.parentFrame, bo.parentFrame);
        aron::fromAron(dto.frame, bo.frame);
        aron::fromAron(dto.agent, bo.agent);
        aron::fromAron(dto.timestamp, bo.timestamp);
    }

    /* JointState */

    void fromAron(const arondto::JointState& dto, robot_state::JointState& bo)
    {
        aron::fromAron(dto.name, bo.name);
        aron::fromAron(dto.position, bo.position);
    }

    void toAron(arondto::JointState& dto, const robot_state::JointState& bo)
    {
        aron::toAron(dto.name, bo.name);
        aron::toAron(dto.position, bo.position);
    }

}  // namespace armarx::armem
