#pragma once

#include <Eigen/Geometry>

namespace armarx::armem::robot_state
{
    struct TransformHeader
    {
        std::string parentFrame;
        std::string frame;

        std::string agent;

        std::int64_t timestamp; // [µs]
    };

    struct Transform
    {
        TransformHeader header;

        Eigen::Affine3f transform = Eigen::Affine3f::Identity();

        EIGEN_MAKE_ALIGNED_OPERATOR_NEW
    };

    struct JointState
    {
        std::string name;
        float position;
    };

}  // namespace armarx::armem::robot_state
